package sun.misc;

import java.util.jar.Manifest;
import java.util.jar.Attributes;
import java.util.jar.JarFile;
import java.io.IOException;
import java.util.Iterator;
import java.io.ByteArrayOutputStream;
import java.util.Properties;

public class VMSupport
{
    private static Properties agentProps;
    
    public VMSupport() {
    }
    
    public static synchronized Properties getAgentProperties() {
        if (VMSupport.agentProps == null) {
            initAgentProperties(VMSupport.agentProps = new Properties());
        }
        return VMSupport.agentProps;
    }
    
    private static native Properties initAgentProperties(Properties p0);
    
    private static byte[] serializePropertiesToByteArray(Properties properties) throws IOException {
        ByteArrayOutputStream out = new ByteArrayOutputStream(4096);
        Properties properties2 = new Properties();
        for (String s : properties.stringPropertyNames()) {
            properties2.put(s, properties.getProperty(s));
        }
        properties2.store(out, null);
        return out.toByteArray();
    }
    
    public static byte[] serializePropertiesToByteArray() throws IOException {
        return serializePropertiesToByteArray(System.getProperties());
    }
    
    public static byte[] serializeAgentPropertiesToByteArray() throws IOException {
        return serializePropertiesToByteArray(getAgentProperties());
    }
    
    public static boolean isClassPathAttributePresent(String name) {
        try {
            Manifest manifest = new JarFile(name).getManifest();
            return manifest != null && manifest.getMainAttributes().getValue(Attributes.Name.CLASS_PATH) != null;
        }
        catch (IOException ex) {
            throw new RuntimeException(ex.getMessage());
        }
    }
    
    public static native String getVMTemporaryDirectory();
    
    static {
        VMSupport.agentProps = null;
    }
}
